// Vehicle //
/////////////
	
datablock WheeledVehicleData(UrbanCarVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "~/data/shapes/vehicles/urbancar/urbancarv6.dts"; //
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 4;
   mountThread[0] = "sitting";
   mountThread[1] = "sitting";
   mountThread[2] = "sitting";
   mountThread[3] = "sitting";

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0.2 0.2";
	//massCenter = "0 -0.2 0";    // Center of mass for rigid body
   //massBox = "2 5 1";

	maxSteeringAngle = 0.685;  // Maximum steering angle, should match animation
	integration = 1;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 15;         // Far distance from vehicle
	cameraOffset = 5.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
    collisionTol = 0.1;        // Collision distance tolerance
    contactTol = 0.1;

	useEyePoint = false;	

	//defaultTire	= urbanwheelTire;
	//defaultSpring	= urbancarSpring;
	//flatTire	= jeepFlatTire;
	//flatSpring	= jeepFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 1000;
	density = 2.6;
	drag = 1.6;
	bodyFriction = 1.6;
	bodyRestitution = 1.4;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 8000; //4000;       // Engine power
	engineBrake = 600;         // Braking when throttle is 0
	brakeTorque = 7000;        // When brakes are applied
	maxWheelSpeed = 300;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

   // Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 0.9;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.1;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skiddingSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	mountPose[0] = "fall";
	
	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "UrbanCar ";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   //initialExplosionProjectile = urbancarExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 8;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};

function UrbanCarVehicle::onAdd(%this,%obj)
{
	parent::onadd(%this,%obj);
	%obj.setWheelTire(0, DefaultCarTire);
	%obj.setWheelTire(1, DefaultCarTire);
	%obj.setWheelTire(2, DefaultCarTire);
	%obj.setWheelTire(3, DefaultCarTire);

	%obj.setWheelSpring(0, DefaultCarSpring);
	%obj.setWheelSpring(1, DefaultCarSpring);
	%obj.setWheelSpring(2, DefaultCarSpring);
	%obj.setWheelSpring(3, DefaultCarSpring);
	
	%obj.setWheelPowered(0, true );
	%obj.setWheelPowered(1, true );
	%obj.setWheelPowered(2, true );
	%obj.setWheelPowered(3, true );

	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);

	%obj.mountable = true;
	%obj.playthread(0, root);

}
function UrbanCarVehicle::onHood(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.hoodTime) > 900)
	{
		%obj.hoodTime = %time;
		%obj.hood = !%obj.hood;
		%obj.playThread(0, %obj.hood ? bonnetlidopen : bonnetlidclose);
	}
	return 1;
}
function UrbanCarVehicle::onTrunk(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.trunkTime) > 900)
	{
		%obj.trunkTime = %time;
		%obj.trunk = !%obj.trunk;
		%obj.playThread(1, %obj.trunk ? bootlidopen : bootlidclose);
	}
	return 1;
}
function UrbanCarVehicle::onLeftDoor(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.leftDoorTime) > 900)
	{
		%obj.leftDoorTime = %time;
		%obj.leftDoor = !%obj.leftDoor;
		%obj.playThread(2, %obj.leftDoor ? ldopen : ldclose);
	}
	return 1;
}
function UrbanCarVehicle::onRightDoor(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.rightDoorTime) > 900)
	{
		%obj.rightDoorTime = %time;
		%obj.rightDoor = !%obj.rightDoor;
		%obj.playThread(3, %obj.rightDoor ? rdopen : rdclose);
	}
	return 1;
}